/*
 * DBIncidents.java
 *
 * Created on February 26, 2004, 6:08 PM
 */

package com.aeat.db;

import com.aeat.db.DBQuery;
import java.util.ArrayList;
import java.sql.ResultSet;
import java.sql.SQLException;
import org.apache.log4j.Logger;

/**
 *
 * @author  tiff
 */
public class DBIncidents 
{
    private int     relatedServiceId;
    private int     relatedIssueId;
    private DBQuery dbQuery;
    private ResultSet IncidentDisplayList;
    private String username;
    private final static Logger DBILogger = Logger.getLogger("Database."+DBIncidents.class);
    
    /** Creates a new instance of DBIncidents */
    public DBIncidents() 
    {
        relatedServiceId =0;
        relatedIssueId =0;
        try
        {
        dbQuery = new DBQuery();
        }
        catch (Exception e)
        {
            DBILogger.fatal("exception from DBQuery", e);
        };
    }
    
    /**
     * Getter for property IncidentDisplayList.
     * @return Value of property IncidentDisplayList.
     */
    public ResultSet getIncidentDisplayList() 
    {
       setIncidentDisplayList();
        return IncidentDisplayList;
    }
    
    /**
     * Setter for property IncidentDisplayList.
     * @param IncidentDisplayList New value of property IncidentDisplayList.
     */
    private void setIncidentDisplayList() 
    {
        //repopulate the list
        /**  Retrieve the filter information for the user specified
        */
        String filterstmnt = "SELECT OnTitle on_title,"
                             + "TitlePattern title_pattern,"
	                     + "OnType on_type,"
	                     + "EveryType every_type,"
	                     + "Communication t_communication,"
	                     + "Control t_control,"
	                     + "Electrification t_electrification,"
	                     + "Intrusion t_intrusion,"
	                     + "Maintenance t_maintenance,"
	                     + "NearMiss t_near_miss,"
	                     + "Passenger t_passenger,"
	                     + "PublicIncident t_public,"
	                     +  "Signals t_signals,"
	                     + "Staff t_staff,"
	                     + "Structure t_structure,"
	                     + "Track t_track,"
	                     + "Train t_train,"
	                     + "Weather t_weather,"
	                     + "OnOpState on_op_state,"
	                     + "OpStateOpen s_open,"
	                     + "OpStateClosed s_closed "
                             + "FROM IncidentFilter WHERE Username=UPPER('"+username+"')";

        String basestmnt = "SELECT inc.IncidentNumber incident_number,"
                         + "to_char(inc.created,'HH24:MI DD-MM-YY') raised,"
                         + "it.Description incident_type,"
                         + "inc.Title title,"
                         + "op.Description op_state,"
                         + "rg.Description reporting_group ";
        String filter = "";
        try
        {
            ResultSet fset = dbQuery.Execute(filterstmnt);


            /**  Base filter request assuming that the filter is wide-open
            */


            if(relatedServiceId > 0) 
            {
                basestmnt += ", (SELECT count(*) FROM Service_Incident si "
                          + "    WHERE inc.IncidentNumber = si.IncidentNumber"
			  + "      AND si.a_ServiceId = "+ Integer.toString(relatedServiceId) +") related_services ";
            }

            if(relatedIssueId > 0) 
            {
		basestmnt += ", (SELECT count(*) FROM Incident_Issue si "
			   + "    WHERE si.IncidentNumber = i.IncidentNumber"
			   + "      AND si.IssueId = "+ Integer.toString(relatedIssueId) +") related_issues ";
            }

        
            basestmnt += "FROM Incident inc,IncidentType it, ReportingGroup rg, OpState op "
                      + "WHERE inc.IncidentTypeId = it.IncidentTypeId "
                      + "AND   inc.ReportingGroupId = rg.ReportingGroupId "
                      + "AND   inc.OpStateId = op.OpStateId ";

	
            /**  Add additional where clauses onto the base sql statement
            */
            if(fset.next())
            {

                /**
		if(fset.getBoolean("on_title") && !fset.getString("title_pattern").equals(".*"){
                	filter += "and inc.Title like " + fset.getString("title_pattern");
		}
                */
		if(fset.getBoolean("on_op_state"))
                {
                    String fltr = "";
                    if(fset.getBoolean("s_open")) 
                    {
			fltr += "op.Description='Open'";
                    }
                    if(fset.getInt("s_closed")>0) 
                    {
			if(fltr.length()>0) fltr += " OR ";
			fltr += "op.Description='Closed'";
                    }
                    if(fltr.length()>0)
                    {
			filter += " AND (" + fltr + ")";
                    }
		}
		if(fset.getBoolean("on_type") && !fset.getBoolean("every_type"))
                {
                    String trfltr = "";
                    if(fset.getBoolean("t_communication"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Communication'";	
                    }
                    if(fset.getBoolean("t_control"))
                    {
			if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Control'";	
                    }
                    if(fset.getBoolean("t_electrification"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Electrification'";	
                    }
                    if(fset.getBoolean("t_intrusion"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Intrusion'";	
                    }
                    if(fset.getBoolean("t_maintenance"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Maintenance'";	
                    }
                    if(fset.getBoolean("t_near_miss"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='NearMiss'";	
                    }
                    if(fset.getBoolean("t_passenger"))
                    {
			if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Passenger'";	
                    }
                    if(fset.getBoolean("t_public"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Public'";	
                    }
                    if(fset.getBoolean("t_signals"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Signals'";	
                    }
                    if(fset.getBoolean("t_staff"))
                    {
                    	if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Staff'";	
                    }
                    if(fset.getBoolean("t_structure"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Structure'";	
                    }
                    if(fset.getBoolean("t_track"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Track'";	
                    }
                    if(fset.getBoolean("t_train"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Train'";	
                    }
                    if(fset.getBoolean("t_weather"))
                    {
                        if(trfltr.length()>0) trfltr += " OR ";
			trfltr += "it.Description='Weather'";	
                    }
                    if(trfltr.length()>0)
                    {
                    	filter += " AND (" + trfltr + ")";
                    }
		
                }
	
            }
	
            fset.close();
        
            this.IncidentDisplayList = dbQuery.Execute(basestmnt+filter);
        }
        catch (SQLException e)
        {};
    }
    
    /**
     * Getter for property relatedIssueId.
     * @return Value of property relatedIssueId.
     */
    public int getRelatedIssueId() {
        return relatedIssueId;
    }
    
    /**
     * Setter for property relatedIssueId.
     * @param relatedIssueId New value of property relatedIssueId.
     */
    public void setRelatedIssueId(int relatedIssueId) {
        this.relatedIssueId = relatedIssueId;
    }
    
    /**
     * Getter for property relatedServiceId.
     * @return Value of property relatedServiceId.
     */
    public int getRelatedServiceId() {
        return relatedServiceId;
    }
    
    /**
     * Setter for property relatedServiceId.
     * @param relatedServiceId New value of property relatedServiceId.
     */
    public void setRelatedServiceId(int relatedServiceId) {
        this.relatedServiceId = relatedServiceId;
    }
    
    /** Getter for property username.
     * @return Value of property username.
     *
     */
    public java.lang.String getUsername() {
        return username;
    }    
    
    /** Setter for property username.
     * @param username New value of property username.
     *
     */
    public void setUsername(java.lang.String username) {
        this.username = username;
    }
    
}
