/* $Id: DBQuery.java,v 1.5 2003/11/20 09:32:15 tiff Exp $ */

package com.aeat.db;

import java.sql.*;
import javax.sql.*;
import java.io.*;
import javax.naming.InitialContext;
import javax.naming.Context;
import javax.naming.NamingException;
import java.util.Date;
import java.util.ArrayList;
// import log4j packages
import org.apache.log4j.Logger;

public class DBQuery 
{
    InitialContext m_InitialContext;
    DataSource     m_DataSource;
    Connection     m_Connection;
    Statement      m_Statement;
    boolean        m_AllowNesting;
    ArrayList      m_Statements;
    private final static Logger QueryLogger = Logger.getLogger("Database."+DBQuery.class);
    public DBQuery() throws SQLException, NamingException 
    {
	m_InitialContext = new InitialContext();
	m_DataSource = (DataSource)m_InitialContext.lookup("java:comp/env/jdbc/TiXdb");
	m_Connection = m_DataSource.getConnection();
	m_Statement = m_Connection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
        m_AllowNesting = false;
	m_Statements = new ArrayList();
    }

    /**  Each call will be executed in a seperate Statement. The Statement will be 
     *   closed when the DBQuery is closed unless Release is called.
     */
    public ResultSet Execute(String stmnt) throws SQLException 
    {
	QueryLogger.info("In DBQuery::Execute "+ (m_AllowNesting?"NESTED":""));
	QueryLogger.debug(stmnt);
	
	ResultSet Reslt;
	
	Statement st;
	if(m_AllowNesting) {
		st = m_Connection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
		m_Statements.add(st);
	}
	else {
		st = m_Statement;
	}

	Reslt = st.executeQuery(stmnt);
	QueryLogger.info("Exiting DBQuery::Execute"+"\n");
	return Reslt;
    }

    public void Close() throws SQLException, NamingException
    {
	m_Connection.close();
	m_InitialContext.close();
    }

    /**  Creates a new Statement for each of the calls to Execute
      */
    public void setAllowNesting(boolean allow) {
	m_AllowNesting = allow;
    }

    public void Commit() throws SQLException {
        m_Connection.commit();
    }
}
