/* $Id: PasswordEncoder.java,v 1.1 2003/04/15 14:19:29 nigeld Exp $ */
package com.aeat.util;

import java.security.*; 


public class PasswordEncoder 
{ 

	private MessageDigest md = null; 
	static private PasswordEncoder md5 = null; 
	private static final char[] hexChars ={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'}; 

	/** 
	* Constructor is private so you must use the getInstance method 
	*/ 
	private PasswordEncoder() throws NoSuchAlgorithmException 
	{ 
		md = MessageDigest.getInstance("MD5"); 
	} 


	/** 
	* This returns the singleton instance 
	*/ 
	public static PasswordEncoder getInstance()throws NoSuchAlgorithmException 
	{ 

		if (md5 == null) 
		{ 
			md5 = new PasswordEncoder(); 
		} 

		return (md5); 
	} 

	/** 
	* Encrpyt passed password
	*/ 
	public static String encrypt(String password)
	{
		String encoded = "";
		try
		{
			PasswordEncoder md = PasswordEncoder.getInstance();
			encoded = md.hashData(password.getBytes());
		}
		catch (NoSuchAlgorithmException e)
		{
			e.printStackTrace(System.out);
		}

		return encoded;
	}

	public String hashData(byte[] dataToHash) 
	{ 
		return hexStringFromBytes((calculateHash(dataToHash))); 
	} 


	private byte[] calculateHash(byte[] dataToHash) 
	{ 
		md.update(dataToHash, 0, dataToHash.length); 
		return (md.digest()); 
	} 


	public String hexStringFromBytes(byte[] b) 
	{ 
		String hex = ""; 
		int msb; 
		int lsb = 0; 
		int i; 
		// MSB maps to idx 0 
		for (i = 0; i < b.length; i++) 
		{ 
			msb = ((int)b[i] & 0x000000FF) / 16; 
			lsb = ((int)b[i] & 0x000000FF) % 16; 
			hex = hex + hexChars[msb] + hexChars[lsb]; 
		} 
		return(hex); 
	} 
} 
